#include <bits/stdc++.h>
using namespace std;

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n >> ws;

    string raw_pattern;
    getline(cin, raw_pattern);

    vector<bool> inverse (104);
    vector<set<int>> matching (104);

    int j = 0;
    string pattern;
    for (int i = 0; i < n; i++) {
        pattern.push_back(raw_pattern[i]);
        if (raw_pattern[i] == '[') {
            while (raw_pattern[++i] != ']') {
                if (raw_pattern[i] == '^') { inverse[j] = true; }
                else if (raw_pattern[i+1] == '-') {
                    for (char c = raw_pattern[i]; c <= raw_pattern[i+2]; c++) {
                        matching[j].insert(c);
                    }
                    i += 2;
                } else {
                    matching[j].insert(raw_pattern[i]);
                }
            }
        }
        j++;
    }
    n = j;

    int q;
    cin >> q;

    while (q--) {
        int m;
        cin >> m >> ws;

        string s;
        getline(cin, s);

        vector<vector<bool>> lookup(m+1, vector<bool>(n+1));

        lookup[0][0] = true;

        for (int j = 1; j <= n; j++) if (pattern[j-1] == '%') {
            lookup[0][j] = lookup[0][j-1];
        }

        for (int i = 1; i <= m; i++) {
            for (int j = 1; j <= n; j++) {
                if (pattern[j-1] == '%') {
                    lookup[i][j] = lookup[i][j-1] || lookup[i-1][j];
                } else {
                    bool ok = false;
                    if (pattern[j-1] == '_') {
                        ok = true;
                    } else if (pattern[j-1] == '[') {
                        ok = matching[j-1].count(s[i-1]);
                        ok ^= inverse[j-1];
                    } else if (s[i-1] == pattern[j-1]) {
                        ok = true;
                    }
                    if (ok) {
                        lookup[i][j] = lookup[i-1][j-1];
                    }
                }
            }
        }

        if (lookup[m][n]) {
            cout << s << "\n";
        }
    }
}
